/*
This is starting to get obnoxious.
This technique (of passing an array of output buffers in) works fine in the emulator, but dies magnificently on the non-emulator.

WHY???
So there are multiple different locations of memory...
	...constant
	...shared
	...global
... and a pointer could be among any one of them! Oh noes!
*/

__global__ void kdraw(uint* out[BUFFERLEN], int width, int height) {
	int idx = blockIdx.x * blockDim.x + threadIdx.x;
	int x, y;

	for (x = 0; x < 10; ++x) {
		for (y = 0; y < 10; ++y) {
			out[idx][y*width + x] = 0xffffff00;
		}
	}
}