/*
This doesn't work.
GLEW isn't multithreaded, and making it multithreaded involves making a new rendering context in your new thread - not ideal for this type of work


*/

static CUT_THREADPROC computeThread(computeInfo* nfo) {
	//from NVidia demo simpleTexture3D.cu
	CUDA_SAFE_CALL(cudaGLMapBufferObject((void**)&nfo->output[0], nfo->pbo[1]));

    // call CUDA kernel, writing results to PBO
    kdraw<<<gridSize, blockSize>>>(nfo->output[0], nfo->width, nfo->height);
    CUT_CHECK_ERROR("kernel failed");

    CUDA_SAFE_CALL(cudaGLUnmapBufferObject(nfo->pbo[1]));

	CUT_THREADEND;
}

void displayF() {
	CUTThread tid = 0;
	computeInfo nfo;
	uint* output[BUFFERLEN];
    char title[256];
    sprintf(title, "Fractal %s", "asdf");  
    glutSetWindowTitle(title);

	nfo.pbo = pbo;
	nfo.output = output;
	nfo.width = width;
	nfo.height = height;

	//invoke the compute thread with parameter 0
	tid = cutStartThread((CUT_THREADROUTINE) computeThread, (void*) &nfo);
	
	printf("Thread ID is %d", tid);

	//wait for the (single) thread to complete.
	cutEndThread(tid);

    // display results
    glClear(GL_COLOR_BUFFER_BIT);

    // draw image from PBO
    glDisable(GL_DEPTH_TEST);
    glBindBufferARB(GL_PIXEL_UNPACK_BUFFER_ARB, pbo[1]);
    glDrawPixels(width, height, GL_RGBA, GL_UNSIGNED_BYTE, 0);
    glBindBufferARB(GL_PIXEL_UNPACK_BUFFER_ARB, 0);

    glutSwapBuffers();
    glutReportErrors();
}